/********************************************
  摇杆控制直流电机转速实例程序
  
  直流电机控制占用引脚4、引脚5
  引脚4控制直流电机的正反转——数字量输出
  引脚5控制直流电机的转速——模拟量输出

  摇杆垂直位置模拟量获取占用模拟量引脚0——模拟量输入
  向上推摇杆模拟量值越来越小
  向下拉摇杆模拟量值越来越大
  模拟量范围0至1023

  当摇杆位于中位时，直流电机静止不动
  当向上推动摇杆时，直流电机逐渐加速正转
  当向下拉动摇杆时，直流电机逐渐加速反转
  
  摇杆位置模拟量获取频率为10Hz（每秒10次，0.1秒一次）
  
  created 2011
  checked 2012 5
  by Nille 
  Email：chenille@126.com
 
  This example code is in the public domain.
*********************************************/

int  verticalVal;		//定义整形变量verticalVal存储AD值
/**********************************************
    初始化部分——setup函数
**********************************************/
void setup() 
{ 
  //设置4号引脚为输出，控制直流电机正反转
  pinMode(4, OUTPUT);
  //设置5号引脚为输出，控制直流电机转速
  pinMode(5, OUTPUT);
} 

/**********************************************
    执行部分——loop函数
**********************************************/
void loop() 
{ 
  //延时0.1秒
  delay(100);
  //获取模拟量AD值
  verticalVal = analogRead(0);

  //判断电机正转还是反转
  if(verticalVal < 512)
  {
    //如果模拟量值小于512，则直流电机正转
    //引脚4输出高电平，直流电机正转
    digitalWrite(4, HIGH);
    //设置直流电机转速
    analogWrite(5, map(512- verticalVal, 0, 511, 0, 255));
  }
  else
  {
    //否则直流电机反转
    //引脚4输出低电平，直流电机反转
    digitalWrite(4, LOW);
    //设置直流电机转速
    analogWrite(5, map(verticalVal, 512, 1023, 0, 255));
  }
}
