/********************************************
  hello Arduino实例程序
  
  在1602液晶模块上第一行显示字符串“hello Arduino！”
  同时响应LCD Keypad Shield扩展模块上的“UP”和“DOWN”键：
  当字符串在第一行显示时，按下“DOWN”键，字符串会移动到第二行；
  当字符串在第二行显示时，按下“UP”键，字符串会移动到第一行
  
  4位总线
  * LCD RS 连接到数字I/O PIN8
  * LCD Enable连接到数字I/O PIN9
  * LCD D4连接到数字I/O PIN4
  * LCD D5连接到数字I/O PIN5
  * LCD D6连接到数字I/O PIN6
  * LCD D7连接到数字I/O PIN7
  * LCD 背光灯控制使用数字I/O PIN10

  created 2011
  checked 2012 5
  by Nille 
  Email：chenille@126.com
 
  This example code is in the public domain.
*********************************************/

// 包含LiquidCrystal库头文件
#include <LiquidCrystal.h>

//声明LiquidCrystal类的对象lcd，同时定义使用的I/O口
LiquidCrystal lcd(8,9,4,5,6,7);

//设置变量keyVal用以保存按键模拟量采集值
int keyVal;

/**********************************************
    初始化部分——setup函数
**********************************************/
void setup() 
{
  // 设置lcd显示的行数和列数 
  lcd.begin(16, 2);
  // 在第一行显示字符串“hello，Arduino！”
  lcd.print("hello, Arduino!");
}

/**********************************************
    执行部分——loop函数
**********************************************/
void loop() 
{ 
  keyVal = analogRead(0);
  //判断按键是否为UP，UP按键按下时，模拟量采样值在120至140范围内
  if(( 120 < keyVal ) && ( keyVal < 140))
  {
    //延时10ms去抖
    delay(10);
    //再进行一次模拟量采集
    keyVal = analogRead(0);
    if(( 120 < keyVal ) && ( keyVal < 140))
    {
      //如果二次采用值仍在120至140区间内
      //则确定按键为UP
      //清除屏幕
      lcd.clear();
      //设定显示位置为第1行第1列
      lcd.setCursor(0,0);
      //重新显示字符串
      lcd.print("hello, Arduino!");
    }
  }
  else if(( 300 < keyVal ) && ( keyVal < 310))
  {
    //判断按键是否为DOWN
    //DOWN按键按下时，模拟量采样值在300至310范围内
		
    //延时10ms去抖
    delay(10);
    //再进行一次模拟量采集
    keyVal = analogRead(0);
    if(( 300 < keyVal ) && ( keyVal < 310))
    {
      //如果二次采用值仍在300至310区间内
      //则确定按键为DOWN
      //清除屏幕
      lcd.clear();
      //设定显示位置为第2行第1列
      lcd.setCursor(0,1);
      //重新显示字符串
      lcd.print("hello, Arduino!");
     }
   }
  //延时0.5秒，0.5秒后在进行按键模拟量采集
  delay(500);	
}
