/********************************************
	XBee应用实例——发送端
  
	每一秒发送一个模拟口5的采样值
  
	created 2011
	by Nille 
	Email：chenille@126.com
 
This example code is in the public domain.
*********************************************/
#include <XBee.h>

// 建立一个xbee的对象
XBee xbee = XBee();

//定义一个数组用于存储要发送的数据
uint8_t payload[] = { 0, 0 };

// 设置接收端的SH + SL地址
XBeeAddress64 addr64 = XBeeAddress64(0x0013a200, 0x403e0f30);
ZBTxRequest zbTx = ZBTxRequest(addr64, payload, sizeof(payload));

//定义变量pin5用于保存采样数据
int pin5 = 0;

/**********************************************
 		初始化部分——setup函数
**********************************************/
void setup() 
{
  xbee.begin(9600);
}

/**********************************************
 		执行部分——loop函数
**********************************************/
void loop()
{   
    pin5 = analogRead(5);		//获取模拟口5的模拟量值，并进行AD转换
    payload[0] = pin5 >> 8 & 0x03;	//由于Arduino的AD是10位的，所以将结果放入两个字节
    payload[1] = pin5 & 0xff;
    
    xbee.send(zbTx);		//发送数据
     
    delay(1000);			//延时1秒
}
